;===========================================================================================
; Mp3.asm  Fasm Flat assembler
; Excuter un fichier au format MP3
; Programm par AsmGges France
;===========================================================================================

format PE GUI 4.0
entry start

; Inclusion des macros/quates/structures ncessaires au programme
; ----------------------------------------------------------------
  include 'win32a.inc'
  include 'macro\if.inc'

;===========================================================================================
; Dbut du code programme
; -----------------------
section '.code' code readable executable

start:

    ; Obtenir le handle du programme
    ; ------------------------------
    invoke GetModuleHandle,0
    mov [wc.hInstance],eax

    ; Chargement d'une icne
    ; ----------------------
    invoke LoadIcon,[wc.hInstance],IDI_FRANCE
    mov [wc.hIcon],eax

    ; Chargement d'un curseur
    ; -----------------------
    invoke LoadCursor,0,IDC_ARROW
    mov [wc.hCursor],eax

    ; Chargement d'un menu
    ; --------------------
    invoke LoadMenu,[wc.hInstance],IDM_MENU
    mov [hMenu],eax

    ; Obtenir la largeur en pixels de l'cran
    ; ---------------------------------------
    invoke GetSystemMetrics,SM_CXSCREEN
    sub eax,[WinW]
    shr eax,1
    mov [WinX],eax

    ; Obtenir la hauteur en pixels de l'cran
    ; ---------------------------------------
    invoke GetSystemMetrics,SM_CYSCREEN
    sub eax,[WinH]
    shr eax,1
    mov [WinY],eax

    ; Valider le choix de la structure WNDCLASS
    ; -----------------------------------------
    invoke RegisterClass,wc

    ; Cration de la fentre de l'application
    ; ---------------------------------------
    invoke CreateWindowEx,WS_EX_CLIENTEDGE,ClassName,Title,WS_OVERLAPPED+WS_SYSMENU+ \
                          WS_MINIMIZEBOX+WS_VISIBLE,[WinX],[WinY],[WinW],[WinH],0,[hMenu],\
                                                                        [wc.hInstance],0
    mov [hWnd],eax

    ; Affichage de la fentre
    ; -----------------------
    invoke ShowWindow,[hWnd],SW_SHOWDEFAULT

    ; Rafraichissement de la fentre
    ; ------------------------------
    invoke UpdateWindow,[hWnd]

 ; Boucle de traitement des messages
 ; ---------------------------------
 MessageLoop:
    ; Rceptionne les messages
    ; ------------------------
    invoke GetMessage,msg,0,0,0
    or eax,eax
    jz ExitProgram

    ; Traduit les touches d'entre clavier en messages
    ; ------------------------------------------------
    invoke TranslateMessage,msg

    ; Expdition des messages  la procdure Windows
    ; ----------------------------------------------
    invoke DispatchMessage,msg

    jmp MessageLoop

 ExitProgram:
    ; Fermeture de l'application
    ; --------------------------
    invoke ExitProcess,[msg.wParam]

;===========================================================================================
; Procdure principale Windows
;-------------------------------------------------------------------------------------------
proc WindowProc uses ebx esi edi, @hWnd, @uMsg, @wParam, @lParam

    .if [@uMsg] = WM_CLOSE
        ; Boite  message fin d'application
        ; ---------------------------------
        invoke MessageBox,[@hWnd],MsgEnd,ClassName,MB_OK+MB_ICONINFORMATION

        ; Demande la fin de l'application
        ; -------------------------------
        invoke PostQuitMessage,0

    .elseif [@uMsg] = WM_COMMAND
        .if [@wParam] = IDM_PLAYMP3
            ; Interprter un fichier MP3
            ; --------------------------
            invoke mciSendString,cmd_close,NoText,0,0
            invoke mciSendString,cmd_open,NoText,0,0
            invoke mciSendString,cmd_play,NoText,0,0

        .elseif [@wParam] = IDM_QUITTER
            ; Demande la fin de l'application
            ; -------------------------------
            invoke SendMessage,[@hWnd],WM_SYSCOMMAND,SC_CLOSE,NULL

        .elseif [@wParam] = IDM_ABOUT
            ; Boite  message about
            ; ---------------------
            invoke MessageBox,[@hWnd],MsgBoxM3,ClassName,MB_OK+MB_ICONINFORMATION

        .endif

    .else
        ; Traitement par dfaut des autres messages Windows
        ; -------------------------------------------------
        invoke DefWindowProc,[@hWnd],[@uMsg],[@wParam],[@lParam]
        ret

    .endif

    mov eax,0

    ret
endp

;===========================================================================================
; Dfinitions des datas chaines / variables initialises ou non initialises / structures
;-------------------------------------------------------------------------------------------
section '.data' data readable writeable

  Title       db ' Jouer un fichier MP3',0
  ClassName   db ' AsmGges Win32',0
  MsgEnd      db ' AsmGges France @2006  ',0
  MsgBoxM3    db 'AsmGges France Win32asm Fasm flat assembler',0

  cmd_open    db 'open res\oiseaux.mp3 type MPEGVideo Alias MP3',0
  cmd_play    db 'play MP3',0
  cmd_close   db 'close MP3',0
  NoText      db '',0
  align 4

  WinX        dd 0
  WinY        dd 0
  WinW        dd 400
  WinH        dd 250

  hWnd        dd ?
  hMenu       dd ?
  wc          WNDCLASS  0,WindowProc,0,0,NULL,NULL,NULL,COLOR_WINDOW+1,NULL,ClassName
  msg         MSG

;===========================================================================================
; Inclusion des fichiers .dll contenant les fonctions Windows utilises
;-------------------------------------------------------------------------------------------
section '.idata' import data readable writeable

  library kernel32,'KERNEL32.DLL',\
            user32,'USER32.DLL',\
             winmm,'WINMM.DLL'

  ; Apis Windows dans fichiers dlls
  ; -------------------------------
  include 'apia\kernel32.inc'
  include 'apia\user32.inc'

  import winmm,\
         mciSendCommand,'mciSendCommandA',\
         mciSendString,'mciSendStringA'

;===========================================================================================
; Inclusion des icnes / curseurs / bitmap
;-------------------------------------------------------------------------------------------
section '.rsrc' resource data readable

  directory RT_MENU,menus,\
            RT_ICON,icons,\
            RT_GROUP_ICON,group_icons

  IDI_FRANCE = 17

  resource menus,\
           IDM_MENU,LANG_ENGLISH+SUBLANG_DEFAULT,main_menu

  resource icons,\
           1,LANG_NEUTRAL,icon_data

  resource group_icons,\
           IDI_FRANCE,LANG_NEUTRAL,main_icon

  IDM_MENU    = 37

  IDM_MENU1   = 100
  IDM_PLAYMP3 = 101
  IDM_QUITTER = 102

  IDM_ABOUT   = 300

  menu main_menu
       menuitem '&Fichier',IDM_MENU1,MFR_POPUP
                menuitem '&Executer fichier MP3',IDM_PLAYMP3
                menuseparator
                menuitem '&Quitter',IDM_QUITTER,MFR_END

       menuitem '&A Propos..',IDM_ABOUT,MFR_END

  icon main_icon,icon_data,'res\france.ico'

;===========================================================================================
